
package ca.ubc.cs.elide.ant;

import ca.ubc.cs.elide.utils.*;
import ca.ubc.cs.elide.utils.Main;
import ca.ubc.cs.elide.*;
import ca.ubc.cs.elide.Transform;
import ca.ubc.cs.elide.visitors.*;
import ca.ubc.cs.elide.sable.*;
import ca.ubc.cs.elide.nodes.*;
import ca.ubc.cs.elide.transformations.*;

import org.apache.tools.ant.*;
import org.apache.tools.ant.types.*;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.taskdefs.*;
import org.apache.tools.ant.taskdefs.compilers.*;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;

public class ElideTask extends MatchingTask
{
	PackageTransformFactory transformFactory = new PackageTransformFactory();
	
	public void execute() throws BuildException
	{
		List sources = new ArrayList();
		List aspects = new ArrayList();
		
		if(srcdir != null)
		{
			try
			{
				String[] dirs = srcdir.list();
				for(int i = 0; i < dirs.length; i++)
				{				
					File dir = project.resolveFile(dirs[i]);
					String[] files = getDirectoryScanner(dir).getIncludedFiles();
					for(int j = 0; j < files.length; j++)
					{
						String filename = new File(dir, files[j]).getCanonicalPath();
						if(filename.endsWith(".aspect"))
							aspects.add(new SourceFile(filename));
						else
							sources.add(new SourceFile(filename));
					}
				}
			}
			catch(IOException e){ e.printStackTrace(); }
		}
		
		Transform.setFactory(transformFactory);
		Main main = new Main(sources, aspects);
		FilePrinter printer = new FilePrinter(destdir);
		StartNode tree = main.transform();
		printer.visit(tree);
		
		//new FilePrinter(destDir).visit(new Main(sources, aspects).transform());
	}
	
	private Path srcdir;
	public void setSrcdir(Path srcdir)
	{
		if (this.srcdir == null)
			this.srcdir = srcdir;
		else
			this.srcdir.append(srcdir);
	}
	
	public Path createSrcdir()
	{
		if (srcdir == null)
			srcdir = new Path(project);
 
		return srcdir.createPath();
    }

    private String destdir = "output";
    public void setDestdir(String destdir) 
	{
		try
		{
			this.destdir = project.resolveFile(destdir).getCanonicalPath();
		}
		catch(IOException e) { e.printStackTrace();}
    }
	
	public void setTransformpackage(String transformpackage)
	{
		transformFactory.addPackage(transformpackage);
	}
}