package ca.ubc.cs.elide.crosscutting;

import ca.ubc.cs.elide.*;
import ca.ubc.cs.elide.nodes.*;
import ca.ubc.cs.elide.visitors.*;
import java.util.*;

public class Crosscutter
{
	public static StartNode crosscut(StartNode baseTree, StartNode aspectTree)
	{
		System.out.println("Crosscutting...");
		StartNode baseTreeClone = (StartNode)baseTree.clone();
		
		Iterator t = getTransforms(aspectTree).iterator();
		while( t.hasNext() )
		{
			TransformNode transformNode = (TransformNode)t.next();
			Iterator matches = getMatches(transformNode.getParent(), baseTreeClone).iterator();
			while( matches.hasNext() )
				((ChildBearingNode)matches.next()).add((TransformNode)transformNode.clone());
		}
		return baseTreeClone;
	}
	
	protected static Collection getTransforms(StartNode fromTree)
	{
		Collector transformCollector = new Collector( new Lambda() {
			public Object apply(Object node) {
				return new Boolean(node instanceof TransformNode);
			}
		});
		
		transformCollector.visit(fromTree);
		return transformCollector.getCollection();
	}
	
	protected static Collection getMatches(final ChildBearingNode cNode, StartNode inTree)
	{
		Collector matchCollector = new Collector( new Lambda() {
			public Object apply(Object node) {
				return new Boolean(PatternMatcher.matches(cNode, (ParseNode)node));
			}
		});
		
		matchCollector.visit(inTree);
		return matchCollector.getCollection();
	}	
}