package ca.ubc.cs.elide.nodes;

import ca.ubc.cs.elide.*;
import ca.ubc.cs.elide.visitors.*;
import ca.ubc.cs.elide.utils.*;
import java.util.*;

/**
 * <code>BlockNode</code> objects represent blocks of Java code in the target system.
 */
public class BlockNode extends CodeBearingNode implements CodeNode
{	
	/* Returns the <code>MethodNode</code> corresponding to the method enclosing the 
	 * code block represented by this <code>BlockNode></code> object.
	 */
	public MethodNode getMethod() { return (MethodNode) getAncestor(MethodNode.class); }
	
	boolean isAddableTo(ChildBearingNode node)
	{
		return (node instanceof CodeBearingNode);
	}
}