package ca.ubc.cs.elide.nodes;

import ca.ubc.cs.elide.*;
import ca.ubc.cs.elide.visitors.*;
import ca.ubc.cs.elide.utils.*;

/** A <code>TextNode</code> represents a snippet of Java code
 * inside a block or method. <p>
 * <code>TextNode</code> is the most detail ELIDE shows, with no attempt
 * made to provide a structured representation of the code inside a particular snippet.
  **/
public class TextNode extends ParseNode implements CodeNode
{
	String text = "";
	
	public TextNode() {}
		
	public TextNode(String text)
	{
		this.text = text;
	}
	
	/**
	 * Returns the source code contained by <code>TextNode</code> as a string.
	 **/
	public String getText() { return text; }
	
	/**
	 * Sets the source code contained by this <code>TextNode</code>.
	 **/
	public void setText(String text) { this.text = text; }
	
	boolean isAddableTo(ChildBearingNode node)
	{
		return (node instanceof CodeBearingNode);
	}
}