package ca.ubc.cs.elide.nodes;

import ca.ubc.cs.elide.visitors.*;
import ca.ubc.cs.elide.utils.*;

/**
 * A <code>TypeNode represents a Java class or interface; unlike
 * <code>ClassNode</code>, it provides no information about the type,
 * but simply serves to identify it by name.
 * <p>
 * See {@link ClassNode#forName} to retrieve a <code>ClassNode</code>
 * from a type name.
 **/
public class TypeNode extends ParseNode
{
	public TypeNode() {}
	public TypeNode(String name) { super(name); }

	boolean isAddableTo(ChildBearingNode node)
	{
		return true;
	}
}