package ca.ubc.cs.elide.transforms;

import ca.ubc.cs.elide.nodes.*;
import ca.ubc.cs.elide.*;
import ca.ubc.cs.elide.transformations.*;
import java.util.*;

public class Lambda extends Transform
{
	public static List onceList = new ArrayList();

	public void transform(BlockNode target, List args)
	{
		target.wrap(new TextNode("\n" +
			"new ca.ubc.cs.elide.Lambda() {\n" +
			"	public Object apply(" + paramList(args) + ") {\n" +
			"		" + castStatements(args) +
			"BODY();" +
			"	}\n" +
			"}\n"), "BODY();");
	}
	
	private String paramList(List args)
	{
		StringBuffer paramList = new StringBuffer();
	
		for(int i = 0; i < args.size(); i++)
		{
			paramList.append("Object arg" + i);
			if(i < args.size() - 1)
				paramList.append(", ");
		}
		return paramList.toString();
	}
	
	private String castStatements(List args)
	{
		StringBuffer castStatements = new StringBuffer();
		Iterator i = args.iterator();
		int j = 0;
		
		while(i.hasNext())
		{
			String param = (String) i.next();
			int space = param.indexOf(" ");
			String type = param.substring(0, space);
			String name = param.substring(space);
			
			castStatements.append(type + " " + name + " = (" + type + ") arg" + j++ + ";\n");
		}
		return castStatements.toString();
	}
	
	private static Set dependencySet = new HashSet();
	private static Dependency transform = new Dependency("transform", "Lambda");
	public static Set getDependencySet(Class self) { return dependencySet; }

	static
	{
		dependencySet.add(transform);
	}
	
	static
	{
		transform.addSatisfies("methodDefinition");
	}
}
