package ca.ubc.cs.elide.transforms;

import ca.ubc.cs.elide.nodes.*;
import ca.ubc.cs.elide.*;
import ca.ubc.cs.elide.transformations.*;
import java.util.*;

public class Once extends Transform
{
	public static List onceList = new ArrayList();

	public void transform(CodeBearingNode target, List args)
	{
		TextNode guard = new TextNode("if(!ca.ubc.cs.elide.transforms.Once.onceList.contains("
						+ buildConditionSet(target, args) +
						")) {\n BODY(); " +
						" ca.ubc.cs.elide.transforms.Once.onceList.add(" +
						buildConditionSet(target, args) +
						");\n }");

		target.wrap(guard, "BODY()");
	}
	
	private static Set dependencySet = new HashSet();
	private static Dependency transform = new Dependency("transform", "Once");
	
	public static Set getDependencySet(Class self) { return dependencySet; }

	static
	{
		dependencySet.add(transform);
	}
	
	static
	{
		transform.addSatisfies("methodDefinition");
	}
	
	private String buildConditionSet(ParseNode target, List args)
	{
		StringBuffer conditionText = new StringBuffer(
			"new java.util.HashSet( java.util.Arrays.asList( new Object[] {");
		Iterator i = args.iterator();
		while( i.hasNext() )
		{
			conditionText.append(i.next());
			conditionText.append(","); 
		}
		conditionText.append("} ))");

		return conditionText.toString();
	}
}
