package ca.ubc.cs.elide.visitors;

import ca.ubc.cs.elide.*;
import ca.ubc.cs.elide.nodes.*;
import java.util.*;

public class Collector extends NodeVisitor
{
	private Collection collection = new ArrayList();
	private Lambda condition;
	
	public void visitNode(ChildBearingNode node)
	{
		visitNode((ParseNode)node);
		visitChildren(node);
	}
	
	public void visitNode(ParseNode node)
	{
		if( ((Boolean)condition.apply(node)).booleanValue() )
			collection.add(node);
	}
	
	public Collector(Lambda condition)
	{
		this.condition = condition;
	}
	
	public Collection getCollection() { return collection; }
}