package ca.ubc.cs.elide.visitors;

import ca.ubc.cs.elide.*;
import ca.ubc.cs.elide.utils.*;
import ca.ubc.cs.elide.nodes.*;
import java.util.*;
import java.io.*;

public class FilePrinter extends Printer
{
	String root;
	public FilePrinter(String rootdir)
	{
		super(null);
		this.root = rootdir;
	}
	
	public void visitNode(StartNode node)
	{
		System.out.println("Generating files in " + root + "...");
		visitChildren(node);
	}
	
	public void visitNode(PackageNode node)
	{
		String path = root + File.separator + InternalUtils.getPath(node.getName());
		(new File(path)).mkdirs();
		
		ClassNode[] classes = node.getClasses();
		for(int i = 0; i < classes.length; i++)
		{
			ClassNode klass = classes[i];
			String fileName = path + File.separator + klass.getShortName() + ".java";
			
			try
			{
				writer = new FileWriter(fileName);
				
				System.out.println("Generating " + fileName);
				if(!node.getName().equals(""))
					append("package " + node.getName() + ";\n\n");
					
				append(klass);
				flush();
			}
			catch(IOException e)
			{
				System.out.println("Error while trying to write to file " + fileName);
				System.out.println(e);
				System.exit(1);
			}
		}
	}
}